#include "TI92dasm.h"


List ReadImported(tBuffer * Buffer)
{
 List Ret;
 longword NbLibs, i, Offset;
 char * LibName;
 byte * StartImportTable;
 byte * Rendu;
 char FuncLabel[14]; // xxxxxxxx@nnnn et moins long pour RO/AM calls
 char NumStr[5];


 //DBsymb
 Offset = ToWord(Buffer->File + 0xC); // _main
 if(strncmp(Buffer->File + Offset - 4, "dinf", 4) == 0)
 {
    char Tmp[100], Tmp2[100];
    word dbLabs, dbVars;
    int n, a;
    tListItem * Item;
    int first = 1;

    dbLabs = ((signed int) ToWord(Buffer->File + Offset - 6)) + Offset - 6;
    dbVars = ((signed int) ToWord(Buffer->File + Offset - 8)) + Offset - 8;
    fprintf(stderr, "Reading DB92 symbolic information.\n");

    ListFirst.Add(TypeTexte, Offset, "\tdb92_symbols", 0);
    ListFirst.Add(TypeTexte, 0, "\tinclude\tsymb.inc", 0);

    for(a = -8 ; a < 0 ; a++)
       Buffer->Flags[Offset + a] = 0;

    //Labels
    if(dbLabs)
    {
       Rendu = Buffer->File + dbLabs;
       while(a = ToWord(Rendu))
       {

          Offset = Rendu - Buffer->File + a;
          Rendu += 2;
          n = ToWord(Rendu);
          Rendu += 2;
          strncpy(Tmp, Rendu, n - 2);
          Tmp[n - 2] = 0;
          if(Item = ListLabels.Search(Offset))
          {
             ListLabels.Rm(Item);
          }
          ListLabels.Add(TypeLabel, Offset, Tmp, 0);

          sprintf(Tmp2, "\t dbl_add %s", Tmp);
          if(first)
          {
             ListFirst.Add(TypeTexte, Rendu - Buffer->File - 4, "\tdbl_begin", 0);
             first = 0;
          }
          ListFirst.Add(TypeTexte, Rendu - Buffer->File - 4, Tmp2,0);

          Rendu += n - 2;
       }
       ListFirst.Add(TypeTexte, Rendu - Buffer->File, "\tdbl_end", 0);
       Rendu += 2;
       Rendu = Buffer->Flags + (Rendu - Buffer->File);
       byte * Index;
       for(Index = Buffer->Flags + dbLabs ; Index < Rendu ; Index++)
          *Index = 0;
    }

    first = 1;
    // Variables
    if(dbVars)
    {
       Rendu = Buffer->File + dbVars;
       while(a = ToWord(Rendu))
       {
          Offset = Rendu - Buffer->File + a;
          Rendu += 2;
          n = ToWord(Rendu);
          Rendu += 3;
          strncpy(Tmp, Rendu, n - 2);
          Tmp[n - 3] = 0;

          if(Item = ListLabels.Search(Offset))
          {
             ListLabels.Rm(Item);
          }
          ListLabels.Add(TypeLabel, Offset, Tmp, 0);

          sprintf(Tmp2, "\t dbv_add %s,dbv_BYTE", Tmp);
          if(first)
          {
             ListFirst.Add(TypeTexte, Rendu - Buffer->File - 6, "\tdbv_begin", 0);
             first = 0;
          }
          ListFirst.Add(TypeTexte, Rendu - Buffer->File - 6, Tmp2, 0);

          Rendu += n - 3;
       }
       ListFirst.Add(TypeTexte, Rendu - Buffer->File, "\tdbv_end", 0);
       Rendu += 2;
       Rendu = Buffer->Flags + (Rendu - Buffer->File);
       byte * Index;
       for(Index = Buffer->Flags + dbVars ; Index < Rendu ; Index++)
          *Index = 0;
    }
 }

 // Imported
 NbLibs = ToWord(Buffer->File + 0x1A);
 StartImportTable = Buffer->File + 0x1A + 2;
 LibName = StartImportTable;
 Rendu = StartImportTable + NbLibs * 10;
 for(i = 1 ; i <= NbLibs ; i++)
 {
  word j;
  word NbFuncs = ToWord(Rendu) + 1;
  Rendu += 2;

  for(j = 1 ; j <= NbFuncs ; j++)
  {
   word Offset;
   word FuncNum = ToWord(Rendu);
   Rendu += 2;

   strcpy(FuncLabel, LibName);
   strcat(FuncLabel, "@");
   sprintf(NumStr, "%04X", FuncNum);
   strcat(FuncLabel, NumStr);


   while(Offset = ToWord(Rendu))
   {
    Ret.Add(TypeImported, Offset, FuncLabel, FuncNum);
    Rendu += 2;
   }
   Rendu += 2;
  }
  LibName += 10;
 }

 // ROM CALLs
 NbLibs = ToWord(Rendu);
 Rendu += 2;
 if(NbLibs) // si ROMCALLs
 {
  NbLibs = ToWord(Rendu) + 1;
  Rendu += 2;

  for(i = 1 ; i <= NbLibs ; i++)
  {
   int len;
   word Offset;
   word FuncNum = ToWord(Rendu);
   Rendu += 2;

   strcpy(FuncLabel, "_ROM_CALL_");
   sprintf(NumStr, "%03X", FuncNum);
   strcat(FuncLabel, NumStr);

   while(Offset = ToWord(Rendu))
   {
    Ret.Add(TypeROM_CALL, Offset, FuncLabel, FuncNum);
    Rendu += 2;
   }
   Rendu += 2;
  }
 }

 // RAM CALLs
 NbLibs = ToWord(Rendu);
 Rendu += 2;
 if(NbLibs) // si RAMCALLs
 {
  NbLibs = ToWord(Rendu) + 1;
  Rendu += 2;

  for(i = 1 ; i <= NbLibs ; i++)
  {
   word Offset;
   word FuncNum = ToWord(Rendu);
   Rendu += 2;

   strcpy(FuncLabel, "_RAM_CALL_");
   sprintf(NumStr, "%03X", FuncNum & 0x3FFF);
   strcat(FuncLabel, NumStr);

   while(Offset = ToWord(Rendu))
   {
    Ret.Add(TypeRAM_CALL, Offset, FuncLabel, FuncNum);
    Rendu += 2;
   }
   Rendu += 2;
  }
 }

 // Reloc
 while(Offset = ToWord(Rendu))
 {
  word PointTo = ToWord(Buffer->File + Offset + 2);
  Ret.Add(TypeReloc, Offset, GetLabelName(PointTo), PointTo); // Add the label for PointTo if necessary
  Rendu += 2;
 }
 Rendu += 2;


 if(ToWord(Buffer->File + 0x14))
 {
    char Tmp[20];

    NbLibs = ToWord(Rendu);// BSS
    Rendu += 2;
    NbLibs = (NbLibs << 16) + ToWord(Rendu);// BSS
    Rendu += 2;
    while(Offset = ToWord(Rendu))
    {
       word PointTo = ToWord(Buffer->File + Offset + 2);
       sprintf(Tmp, "BSS%04X", PointTo);
       Ret.Add(TypeBSS, Offset, Tmp, PointTo); // Add the label for PointTo if necessary

       Rendu += 2;
    }
    Rendu += 2;

    ListFirst.Add(TypeTexte, 65535, "\tBSS", 0);
    tListItem * Current = NULL;
    List TmpList;

    while(Current = Ret.GetNext(Current, TypeBSS))
    {
       if(!TmpList.Search(Current->PointTo))
          TmpList.Add(TypeTexte, Current->PointTo, Current->Label, 0);
    }

    TmpList.SortFollowingToOffset();

    Current = NULL;
    int First = 1;
    while(Current = TmpList.GetNext(Current))
    {
       if(First)
       {
          sprintf(Tmp, "\tds.b\t%d", Current->Offset);
          ListFirst.Add(TypeTexte, 65535, Tmp, 0);
          First = 0;
       }
       ListFirst.Add(TypeTexte, 65535, Current->Label, 0);
       if(Current->Next)
       {
          sprintf(Tmp, "\tds.b\t%d", Current->Next->Offset - Current->Offset);
       }
       else
       {
          sprintf(Tmp, "\tds.b\t%d", NbLibs - Current->Offset);
       }
       ListFirst.Add(TypeTexte, 65535, Tmp, 0);
    }
    TmpList.Free();

 }

 if(ToWord(Buffer->File + 0x16))
 {
    NbLibs = ToWord(Rendu); // Export
    Rendu += 2;
    word FuncNum;
    for(FuncNum = 0 ; FuncNum < NbLibs ; FuncNum++)
    {
       Offset = ToWord(Rendu);
       Rendu += 2;
       char Tmp[14]; // nnnnnnnn@nnnn
       char Tmp2[14+6];
       sprintf(Tmp, "%s@%04X", Buffer->Name, FuncNum);
       ListLabels.Add(TypeLabel, Offset, Tmp, 0);
       ListEntryPoints.Add(TypeEntryPoint, Offset, Tmp, FuncNum); // Add the label for PointTo if necessary
       sprintf(Tmp2, "\txdef\t%s", Tmp);
       ListFirst.Add(TypeTexte, 0, Tmp2, 0);
    }
 }


 byte * RenduTmp = Rendu;
 Rendu = Buffer->File + 2 + ToWord(Buffer->File + 2);
 if(!strncmp("68kL", Buffer->File + 4, 4))
 {
    Rendu += 40; // Stub
    while(ToWord(Rendu)) Rendu += 2;
    Rendu += 2;
 }
 else
 {
    Rendu += 16;
    if((RenduTmp != Rendu) && (*Rendu == 0x4E))
       Rendu += 4;
 }

 word Index;
 for(Index = 0 ; Index < Rendu - Buffer->File ; Index++)
    Buffer->Flags[Index] = 0;

 Index = Buffer->Size - 1;
 Buffer->Flags[Index] = 0;
 Index -= 2;
 while(ToWord(Buffer->File + Index))
 {
    Buffer->Flags[Index] = 0;
    Buffer->Flags[Index + 1] = 0;
    Index -= 2;
 }
 Buffer->Flags[Index] = 0;
 Buffer->Flags[Index + 1] = 0;




 return Ret;
}